%ZUTILS ;V4W/DLW-FREEM POLYFILLS; 10/23/2020 6:55 PM
    ;0.0;FreeM;****FREEM**;John P Willis @2020
    ;
    ;                            *
    ;                           * *
    ;                          *   *
    ;                     ***************
    ;                      * *       * *
    ;                       *  MUMPS  *
    ;                      * *       * *
    ;                     ***************
    ;                          *   *
    ;                           * *
    ;                            *
    ;
    ;   %ZUTILS.m
    ;    FreeM Polyfills
    ;
    ;  
    ;   Author: David Wicksell <dlwicksell@fourthwatchsoftware.com>
    ;    Copyright (C) 1998 MUG Deutschland
    ;    Copyright (C) 2020 Fourth Watch Software LC
    ;
    ;
    ;   This file is part of FreeM.
    ;
    ;   FreeM is free software: you can redistribute it and/or modify
    ;   it under the terms of the GNU Affero Public License as published by
    ;   the Free Software Foundation, either version 3 of the License, or
    ;   (at your option) any later version.
    ;
    ;   FreeM is distributed in the hope that it will be useful,
    ;   but WITHOUT ANY WARRANTY; without even the implied warranty of
    ;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    ;   GNU Affero Public License for more details.
    ;
    ;   You should have received a copy of the GNU Affero Public License
    ;   along with FreeM.  If not, see <https://www.gnu.org/licenses/>.
    ;
MERGE(SOURCE,DESTINATION) ; Implement the MERGE command
	; SOURCE = M array to merge from passed by name indirection
 	; DESTINATION = M array to merge to passed by name indirection
 	; returns 0 on success, -1 on error
 	;
 	; SOURCE is an array descendant of DESTINATION; throw M19 (error code 158)
 	IF $EXTRACT(SOURCE,1,$LENGTH(DESTINATION))=DESTINATION QUIT -1
 	; DESTINATION is an array descendant of SOURCE; throw M19 (error code 158)
 	IF $EXTRACT(DESTINATION,1,$LENGTH(SOURCE))=SOURCE QUIT -1
 	;
 	; set DESTINATION clear base name
 	NEW DST
 	SET DST=DESTINATION
 	;
 	; set SOURCE break flag
 	NEW SRC
 	SET SRC=SOURCE,$QSUBSCRIPT(SRC,0)="",$EXTRACT(SRC,$LENGTH(SRC))=""
 	;
 	; set the SOURCE POP offset
 	NEW POP
 	IF $QLENGTH(SOURCE)>$QLENGTH(DESTINATION) SET POP=$QLENGTH(SOURCE)-$QLENGTH(DESTINATION)
 	ELSE  SET POP=0
 	;
 	; set the DESTINATION PUSH offset
 	NEW PUSH
 	IF $QLENGTH(DESTINATION)>$QLENGTH(SOURCE) SET PUSH=$QLENGTH(DESTINATION)-$QLENGTH(SOURCE)
 	ELSE  SET PUSH=0
 	;
 	; merge initial node, if it exists
 	SET:$DATA(@SOURCE)#2 @DESTINATION=@SOURCE
 	;
 	; merge the rest of the nodes
 	NEW I,TST
 	FOR  SET SOURCE=$QUERY(@SOURCE) QUIT:(SOURCE="")!(SRC=-1)  DO
 	. ; quit at the end of a SOURCE sub-tree
 	. SET TST=SOURCE,$QSUBSCRIPT(TST,0)="",TST=$EXTRACT(TST,1,$LENGTH(SRC))
 	. IF TST'=SRC SET SRC=-1 QUIT
 	. ;
 	. ; clear DESTINATION keys
 	. SET DESTINATION=DST
 	. ; rebuild the DESTINATION array keys
 	. FOR I=1:1:($QLENGTH(SOURCE)-POP) DO
 	. . SET $QSUBSCRIPT(DESTINATION,I+PUSH)=$QSUBSCRIPT(SOURCE,I+POP)
 	. ;
 	. ; set the next node
 	. SET @DESTINATION=@SOURCE
 	;
 	QUIT 0
